<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Internal DPs</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Internal DPs </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This sections describes DP types, used for AS EWO, their structure and usage.</p>
<p>These internal DPs are used for storing different subsets of NG AS configuration. Unlike many other components, the NG AS does not use rather complex DP structures, with many DPEs, with every DPE storing particular setting. Instead, NG AS uses another approach: there is just one 'main' DPE in every DP type, containing string in JSON format. All individual settings are encoded inside this JSON string.</p>
<p>The names of DP types, used by NG AS, are declared as string constants AS_xxx_DP_TYPE in CTRL library AlarmScreenNg.ctl.</p>
<h1><a class="anchor" id="sec_RefDpNaming"></a>
Automatic DP naming</h1>
<p>For some of DP types, described in the next sections, many DPs can be created in the project. Usually these are DPs, where user may save current configuration (filter, user settings...).</p>
<p>In all such cases, user doesn't specify (and doesn't even see) the name of DP where settings are saved (or from where loaded). Instead, the user is required to enter own unique (and, hopefully, meaningnful) name. Later saved settings are presented to user under this name.</p>
<p>DP names are generated automatically, using the following rule:</p>
<div class="fragment"><div class="line">&lt;dp_type_name&gt;_&lt;user&gt;_&lt;seq_no&gt;</div>
</div><!-- fragment --><p>For example, DPs for user settings, saved by user 'operator', will be named "_NgAsUserSetting_operator_1", "_NgAsUserSetting_operator_2", etc.</p>
<h1><a class="anchor" id="sec_RefDpBasicConfig"></a>
Basic configuration</h1>
<p>The most important configuration for AS EWO, which defines all basic settings, like set of alarm properties, set of columns in table etc. See <a class="el" href="page_RefJson.html#sec_RefJsonBasicConfig">Basic configuration</a> for more details.</p>
<p>The DP type, holding the basic configuration, is called <b>_NgAsConfig</b>. This DP type contains the only DPE <b>ConfigJSON</b> of type <code>string</code>, containing basic configuration in JSON format.</p>
<p>WinCC OA project may contain several DPs of this type with different basic configurations. During component installation, several DPs of this type can be created in the project: they contain some basic configurations, prepared in advance.</p>
<dl class="section note"><dt>Note</dt><dd>The DP with basic configuration is <b>not</b> automatically created/filled during component installation if project already contains DP with such name, and content of existing DP is not empty.</dd></dl>
<h1><a class="anchor" id="sec_RefDpAdminSettings"></a>
Admin settings</h1>
<p>Admin settings for AS EWO are stored in DP of type <b>_NgAsAdmin</b>. DP type contains the following DPEs: </p><ul>
<li>
<b>AccessControl</b>: <code>string</code> containing access control settings in JSON format. See <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">Access Control</a>.  </li>
<li>
<b>PopupMenuJCOP</b>: <code>string</code> containing description of popup menu to be shown when user clicks on alarms table. See <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">Popup menu configuration</a>. <dl class="section note"><dt>Note</dt><dd>Why 'JCOP'? Because UNICOS uses another way for building/processing popup menu.  </dd></dl>
</li>
<li>
<b>HelpConfig</b>: <code>string</code> containing configuration for different types of help files. See <a class="el" href="page_ConfigAdmin.html#sec_HelpFileTypes">Help File Types</a>.  </li>
<li>
<b>ArchiveAccess</b>: <code>string</code> contatining information required for connection to ORACLE archive: database, user name and password.  </li>
</ul>
<p>WinCC OA project shall contain only one DP of this DP type, the DP is named <b>_NgAsAdmin</b>.</p>
<h1><a class="anchor" id="sec_RefDpUserSettings"></a>
User settings</h1>
<p>The set of user settings are stored in DPs of type <b>_NgAsUserSetting</b>. DP type contains the following DPEs: </p><ul>
<li>
<b>ConfigDp</b>: <code>string</code> containing the name of <a class="el" href="page_RefDp.html#sec_RefDpBasicConfig">basic configuration DP</a>, for which this set of user settings is saved. In many cases, user settings prepared for one basic configuration, may not work for other basic configuration (for example, because table columns may have different headers in two configurations).  </li>
<li>
<b>SettingName</b>: <code>string</code> containing the unique name of this setting; the name was given by user when he saved user settings. This name is presented to user when he wants to load one of previously saved user settings.  </li>
<li>
<b>SettingJSON</b>: <code>string</code> containing the set of user settings in JSON format. See <a class="el" href="page_UserSettings.html">User Settings</a>.  </li>
<li>
<b>Usage</b>: <b>uint</b> value, enumerating the usage of this user settings. See <a class="el" href="page_UserSettings.html#sec_UserSettingsDefault">Configuring the default user settings</a>  </li>
<li>
<b>DefaultFilter</b>: <b>uint</b> value, enumerating the usage of default filter, contained in user settings, see <a class="el" href="page_RefJson.html#subsec_RefJsonUserSettings">User settings</a>. The value of this DPE is used when user settings from this DP are loaded into AS EWO. Three values ape possible (see also contants <code>AS_NG_USER_SETTINGS_DFLT_FILTER_xxx</code> defined in CTRL lib): <ul>
<li>
<b>0</b>: when user settings are loaded to AS EWO, the previosuly set default filter for AS EWO remains unchanged. This is the default behavior.  </li>
<li>
<b>1</b>: when user settings are loaded to AS EWO, the default filter of AS EWO is reset to 'empty' filter. Here 'empty' means not necessary empty filter, but rather the filter resulted from default settings in filter editor. One evident example is JCOP-style filter with Warning/Error/Failure checkboxes: the 'emty' in such case means the filter with non-empty filter on alarm priority.  </li>
<li>
<b>2</b>: when user settings are loaded to AS EWO, the default filter of AS EWO is set to the filter saved in this user settings.  </li>
</ul>
Thus, the only way to apply non-empty default filter to AS EWO is loading user settings with the value in this DPE - of course, provided that user settings were saved with non-empty filter.  </li>
</ul>
<p>WinCC OA project may contain many DPs of this DP type: one for every settings, saved by user. The names of DPs are built automatically according to general rules, see <a class="el" href="page_RefDp.html#sec_RefDpNaming">Automatic DP naming</a>.</p>
<h1><a class="anchor" id="sec_RefDpFilter"></a>
Filters</h1>
<p>The structured filters are stored in DPs of type <b>_NgAsFilter</b>. DP type contains the following DPEs:</p>
<ul>
<li>
<b>ConfigDp</b>: <code>string</code> containing the name of <a class="el" href="page_RefDp.html#sec_RefDpBasicConfig">basic configuration DP</a>, for which this filter is saved. In many cases, filter prepared for one basic configuration, may not work for other basic configuration (for example, because set of individual filters are different in different configurations).  </li>
<li>
<b>FilterName</b>: <code>string</code> containing the unique name of this filter; the name was given by user when he saved filter. This name is presented to user when he wants to load one of previously saved filters.  </li>
<li>
<b>FilterJSON</b>: <code>string</code> containing the structured filter in JSON format. See <a class="el" href="page_RefJson.html#subsec_RefJsonFilter">filter</a> JSON syntax.  </li>
<li>
<b>Delete</b>: this DPE is not used (yet?)  </li>
</ul>
<p>WinCC OA project may contain many DPs of this DP type: one for every settings, saved by user. The names of DPs are built automatically according to general rules, see <a class="el" href="page_RefDp.html#sec_RefDpNaming">Automatic DP naming</a>.</p>
<h1><a class="anchor" id="sec_RefDpFilterView"></a>
Filter View</h1>
<p>The configurations for FiolterView are stored in DPs of type <b>_NgAsFilterSet</b>. DP type contains the following DPEs:</p>
<ul>
<li>
<b>ConfigDp</b>: <code>string</code> containing the name of <a class="el" href="page_RefDp.html#sec_RefDpBasicConfig">basic configuration DP</a>, for which this filter view was sbuilt. In many cases, filter view prepared for one basic configuration, may not work for other basic configuration (for example, because set of individual filters are different in different configurations).  </li>
<li>
<b>SetName</b>: <code>string</code> containing the unique name of this filter view; the name was given by user when filter view was created. This name is presented to user when he wants to load one of previously saved filter views.  </li>
<li>
<b>SetJSON</b>: <code>string</code> containing the definition of filter view in JSON format. See <a class="el" href="page_FilterViewEditor.html">Filter View editor</a>.  </li>
</ul>
<p>WinCC OA project may contain many DPs of this DP type: one for every created filter view. The names of DPs are built automatically, but the rules for these DPs are slightly different from common <a class="el" href="page_RefDp.html#sec_RefDpNaming">Automatic DP naming</a>, namely: the names for DPs of this type doesn't contain user name: it is expected that filter views are by default shared by many users.</p>
<h1><a class="anchor" id="sec_RefDpPlot"></a>
Trend configuration</h1>
<p>The trend configuration, used by NG AS, is sitting a bit aside: there is no special DP type for NG AS. Instead, the NG AS reuses existing DP type <b>FwTrendingPlot</b> (coming with fwTrending component) and creates/fills DP of this type called <b>_AlarmScreenNgPlot</b>.</p>
<p>The DP is created/filled either during component installation, or when the trend is being opened for the very first time. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
